# Bobbi's Fork of IP65

I have made the following changes:

## DATE65

 - Load timezone information from `TZONE.TXT` configuration file, rather than hard-coding.
 - Automatically determine if it is DST or not (using North American rules) and choose timezone accordingly.
 - Support for ProDOS 2.5 extended date format.

## Apple II Email Suite

<p align="center"><img src="img/emailler-logo.png" alt="emai//er-logo" height="200px"></p>

See [here](README-emailler.md)

## The original `README.md` follows ...

IP65 consists of three parts:
- A [TCP/IP library to be used by 6502 asm programmers](https://github.com/cc65/ip65/wiki/Library-for-asm-programs) using the [ca65](https://cc65.github.io/doc/ca65.html) macro assembler
- A [TCP/IP library to be used by C programmers](https://github.com/cc65/ip65/wiki/Library-for-C-programs) using the [cc65](https://cc65.github.io/doc/cc65.html) 6502 C cross compiler
- Several [ready-to-run TCP/IP programs](https://github.com/cc65/ip65/wiki/Ready-to-run-TCP_IP-programs) using one of the libraries

All three parts are available for three 6502 based target systems:
- The C64
- The Apple II
- The ATARI (XL)

IP65 requires Ethernet hardware. There's no support for TCP/IP over serial connections whatsoever.

On the C64 there are two supported Ethernet devices:
- The [RR-Net](http://wiki.icomp.de/wiki/RR-Net) - emulated by [VICE](http://vice-emu.sourceforge.net/)
- The [ETH64](https://www.ide64.org/eth64.html)

On the Apple II there are three supported Ethernet cards:
- The [Uthernet](https://web.archive.org/web/20150323031638/http://a2retrosystems.com/products.htm) - emulated by [AppleWin](https://github.com/AppleWin/AppleWin) and [GSport](https://david-schmidt.github.io/gsport/)
- The [LANceGS](https://web.archive.org/web/20010331001718/http://lancegs.a2central.com:80/)
- The [Uthernet II](http://a2retrosystems.com/products.htm)

On the ATARI (XL) there are two supported Ethernet devices:
- The [Dragon Cart](https://www.atari8ethernet.com/) - emulated by [Altirra](http://www.virtualdub.org/altirra.html)
- The [Dracarys](https://atariage.com/forums/topic/287376-preannouncement-dragon-cart-ii/)
